

        DOSSEG
        .MODEL small

         include c:dos.inc
         include c:bios.inc

        .STACK 100H

        .DATA


Public VideoSeg,col1,col2,col3,prog_nom,Dft_Ch,Dft_Prog,Filename
Public ColA,ColB,ColC
Extrn Piano:byte,Tmen1:byte,Tmen2:Byte,Ch_table:byte

;****************Video

        VideoSeg dw 0b800h       ;Video buffer segment, VIDEO procedure
                                ;will change it to 0b000h if monocromatic monitor

        Col1    db 17H          ;Default color
        Col2    db 30H          ;Reverse video
        Col3    db 1Fh          ;Highlight         Colors will be changed to
                                ;                  B&W if mono monitor
        Cola    db 47h          ;Colors for menus
        Colb    db 70h
        Colc    db 4fh

        ExMen1 db ' Return to DOS (Y/N)? ',0

;****************MPU Ports

        Statport equ 331h       ;Status port
        Comport  equ 331h       ;Commands port
        Dataport equ 330h       ;Data port

;****************MPU Masks

        Drr equ 40h             ;Data receive ready mask
        Dsr equ 80h             ;Data set ready mask

;****************MPU Commands

        Wtsd equ 0D0h           ;Want to send data
        Rst  equ 0FFh           ;Mpu reset
        Ack  equ 0FEh           ;Acknowledge
        MidiOff equ 88h         ;Midi thru off

;****************Program's name file data

PROG_NOM LABEL BYTE             ;Program's names file buffer
        db '1',8 dup (32)
        db '2',8 dup (32)
        db '3',8 dup (32)
        db '4',8 dup (32)
        db '5',8 dup (32)
        db '6',8 dup (32)
        db '7',8 dup (32)
        db '8',8 dup (32)
        db '9',8 dup (32)
        db '10',7 dup (32)
        db '11',7 dup (32)
        db '12',7 dup (32)
        db '13',7 dup (32)
        db '14',7 dup (32)
        db '15',7 dup (32)
        db '16',7 dup (32)
        db '17',7 dup (32)
        db '18',7 dup (32)
        db '19',7 dup (32)
        db '20',7 dup (32)
        db '21',7 dup (32)
        db '22',7 dup (32)
        db '23',7 dup (32)
        db '24',7 dup (32)
        db '25',7 dup (32)
        db '26',7 dup (32)
        db '27',7 dup (32)
        db '28',7 dup (32)
        db '29',7 dup (32)
        db '30',7 dup (32)
        db '31',7 dup (32)
        db '32',7 dup (32)
        db '33',7 dup (32)
        db '34',7 dup (32)
        db '35',7 dup (32)
        db '36',7 dup (32)
        db '37',7 dup (32)
        db '38',7 dup (32)
        db '39',7 dup (32)
        db '40',7 dup (32)
        db '41',7 dup (32)
        db '42',7 dup (32)
        db '43',7 dup (32)
        db '44',7 dup (32)
        db '45',7 dup (32)
        db '46',7 dup (32)
        db '47',7 dup (32)
        db '48',7 dup (32)
        db '49',7 dup (32)
        db '50',7 dup (32)
        db '51',7 dup (32)
        db '52',7 dup (32)
        db '53',7 dup (32)
        db '54',7 dup (32)
        db '55',7 dup (32)
        db '56',7 dup (32)
        db '57',7 dup (32)
        db '58',7 dup (32)
        db '59',7 dup (32)
        db '60',7 dup (32)
        db '61',7 dup (32)
        db '62',7 dup (32)
        db '63',7 dup (32)
        db '64',7 dup (32)
        db '65',7 dup (32)
        db '66',7 dup (32)
        db '67',7 dup (32)
        db '68',7 dup (32)
        db '69',7 dup (32)
        db '70',7 dup (32)
        db '71',7 dup (32)
        db '72',7 dup (32)
        db '73',7 dup (32)
        db '74',7 dup (32)
        db '75',7 dup (32)
        db '76',7 dup (32)
        db '77',7 dup (32)
        db '78',7 dup (32)
        db '79',7 dup (32)
        db '80',7 dup (32)
        db '81',7 dup (32)
        db '82',7 dup (32)
        db '83',7 dup (32)
        db '84',7 dup (32)
        db '85',7 dup (32)
        db '86',7 dup (32)
        db '87',7 dup (32)
        db '88',7 dup (32)
        db '89',7 dup (32)
        db '90',7 dup (32)
        db '91',7 dup (32)
        db '92',7 dup (32)
        db '93',7 dup (32)
        db '94',7 dup (32)
        db '95',7 dup (32)
        db '96',7 dup (32)
        db '97',7 dup (32)
        db '98',7 dup (32)
        db '99',7 dup (32)
        db '100',6 dup (32)
        db '101',6 dup (32)
        db '102',6 dup (32)
        db '103',6 dup (32)
        db '104',6 dup (32)
        db '105',6 dup (32)
        db '106',6 dup (32)
        db '107',6 dup (32)
        db '108',6 dup (32)
        db '109',6 dup (32)
        db '110',6 dup (32)
        db '111',6 dup (32)
        db '112',6 dup (32)
        db '113',6 dup (32)
        db '114',6 dup (32)
        db '115',6 dup (32)
        db '116',6 dup (32)
        db '117',6 dup (32)
        db '118',6 dup (32)
        db '119',6 dup (32)
        db '120',6 dup (32)
        db '121',6 dup (32)
        db '122',6 dup (32)
        db '123',6 dup (32)
        db '124',6 dup (32)
        db '125',6 dup (32)
        db '126',6 dup (32)
        db '127',6 dup (32)
        db '128',6 dup (32)

        Dft_prog db 0           ;Default program variable

        Prog_Name_Bf DB 8,0,0,8 DUP (20H),0     ;Buffer for input of program name


;****************Files control and buffers

        Handle dw 0
        Filename_Bf DB 40,0,0           ;filename's buffer control area
        Filename db 40 dup (20h),0      ;filename's buffer


;****************Channel

        Dft_Ch   db 0           ;Default Channel variable

;****************Key table

KE_TB label byte                ;table for functions keys
       db 72
       dw offset UP             ;offset adress of called procedure
       db 75
       dw offset left
       db 77
       dw offset right
       db 80
       dw offset down
       db 60
       dw offset edit
       db 62
       dw offset SlCh
       db 61
       dw offset SendRec
       db 104
       dw offset Ch1
       db 105
       dw offset Ch2
       db 106
       dw offset Ch3
       db 107
       dw offset Ch4
       db 108
       dw offset Ch5
       db 109
       dw offset Ch6
       db 110
       dw offset Ch7
       db 111
       dw offset Ch8
       db 112
       dw offset Ch9
       db 113
       dw offset Ch10
       db 84
       dw offset Ch11
       db 85
       dw offset Ch12
       db 86
       dw offset Ch13
       db 87
       dw offset Ch14
       db 88
       dw offset Ch15
       db 89
       dw offset Ch16
       db 59
       dw offset Help
       db 0

;****************Errors table

        error_table LABEL BYTE
        DB 2                    ;error number
        DW offset ERR2          ;offset of error message
        DB 3
        DW offset ERR3
        DB 5
        DW offset err5
        DB 15
        DW offset err15
        db 99
        dw offset err99
        db 101
        dw offset err101
        db 102
        dw offset err102
        db 103
        dw offset err103
        DB 0
        ERR2 DB '  File not found, press any key.  ',0
        ERR3 DB '  Path not found, press any key.  ',0
        ERR5 DB '  Access denied, press any key.  ',0
        ERR15 DB '  Invalid drive was specified, press any key.  ',0
        ERR99 DB '  File creation error, press any key.  ',0
        ERR100 db ' Cannot read input file, press any key ',0
        ERR101 db ' Data buffer overflow, press any key. ',0
        ERR102 DB ' Input file not a data file, press any key. ',0
        ERR103 db ' Out of memory for input file, press any key. ',0
        ERRIND DB '  Unknown error, press any key.  ',0

.CODE

;Public procedures
Public Program,error,read_data,Clear_bf

;External procedures
Extrn Menu_prog:near,Send_Command:near,ProgFl:near,SlPr:near,Drr_rout:near
Extrn SlCh:near,Disp_EdMenu:near,Name_Box:near,Keyb:near,write:near
Extrn SendRec:near,File_box:near,Retrace:near,Box:near,Display_Slct:near
Extrn Help:near,DosVer:near,Video:near,ChgeColor:near,IntInit:near


SINT PROC               ;Main procedure
        mov ax,@DATA    ;prepare stack and data
        mov ds,ax
        cli
        mov ss,ax
        mov sp,offset stack
        sti
        call DosVer     ;(LI.LIB) Check DOS version
        @ModBlok 865    ;Free extra memory
        call Video      ;(LI.LIB) Check type of monitor
        call IntInit    ;(LI.LIB) Install critical error handler
        cmp VideoSeg,0b000h
        je ColorOk
        call ChgeColor  ;If color monitor change atributtes of menus
ColorOk:
        call MENU_PROG  ;Prepare screen
        call COM_LINE   ;Check for filename in command line
        call init_midi  ;Initialize MPU
loop1:
        lea si,prog_nom     ;Program's name buffer into SI
        call WRITE_NAME     ;Write them to the screen
        call SELECT_PROG    ;Select program
        jc Exit             ;If carry set return to DOS
        call PROGRAM        ;Else send program to synthesizer
        jmp loop1           ;wait for more
Exit:
        mov ah,6
        mov al,0
        mov bh,col1
        mov ch,1
        mov cl,1
        mov dh,18
        mov dl,78
        int 10h         ;Clear screen
        mov ax,1        ;and prepare exit screen
        mov bl,0fh
        mov ch,6
        mov cl,6
        mov dh,15
        mov dl,74
        call BOX        ;(LI.LIB) draw a box
        xor ax,ax
        lea si,piano
        mov ch,7
        mov cl,7
        call write      ;(LI.LIB) write to the screen
        lea si,Tmen1
        mov ch,2
        mov cl,18
        mov bl,col1
        call write
        lea si,Tmen2
        mov ch,4
        mov cl,34
        call write
        lea si,ExMen1
        mov ch,17
        mov cl,29
        mov bl,col2
        call write
        mov ah,7
        int 21h         ;Wait for a key to exit
        and al,11011111b  ;Capitalize
        cmp al,'Y'
        je ExitOk       ;Yes? then exit
        jmp loop1       ;Else return to program
ExitOk:
        mov al,rst          ;Reset Mpu before exit
        call send_command
        mov dh,24
        mov dl,79
        xor cx,cx
        mov bh,7
        @scroll 0           ;Clear screen
        @setcurpos 0,0,0
        @exit 0
SINT endp

;Procedure Com_Line
;Purpose Checks for filename in command line
;Input  ES=PSP
;Output Loads file

Com_Line Proc
        push ds
        push es
        push bp                 ;Use BP to acees stack
        mov bp,sp
        mov si,80h              ;ES:SI points to Program Segment Prefix (PSP)
        cmp byte ptr es:[si],0  ;If = 0  then no file
        jne COMMAND_OK
        pop bp
        pop es
        pop ds                  ;Exit
        ret
COMMAND_OK:
        mov di,offset FILENAME_BF+1    ;else move it into filename buffer
        mov ds,[bp+2]                  ;Move ES into DS
        mov es,[bp+4]                  ;Move DS into ES
        mov cx,1                       ;DS:SI points to PSP
        cld                            ;ES:DI to filename buffer
        rep movsb                      ;move lenght of command line
        mov cl,byte ptr [si-1]
        mov si,82h                     ;move filename
        inc di
        cld
        rep movsb
        mov byte ptr es:[di-1],0       ;end with a zero
        pop bp
        pop es
        pop ds
        @Openfil filename,0           ;Open file
        jc EXIT_COM                   ;If error exit
        mov handle,ax
        @read prog_nom,1152,handle    ;Read it into buffer
        cmp ax,cx
        jne EXIT_COM
        @closfil handle
        call ProgFl                   ;Write filename to screen
EXIT_COM:
        ret
Com_Line Endp


;Procedure Error
;Purpose Displays error messages
;Input  AX=error code

Error Proc
        lea bx,ERROR_table
loop_err:
        cmp byte ptr [bx],0     ;If BX=0 end of table
        je unk_error            ;Display unknown error message
        cmp [bx],al             ;Search for error code match
        je ERROR_found
        add bx,3                ;continue searching
        jmp loop_err
ERROR_found:
        mov si,[bx+1]           ;if match BX+1=adress of message
write_err:
        xor ax,ax
        mov bl,col2
        mov ch,17
        mov cl,21
        call write              ;(LI.LIB) display error message
f_key:
        mov ah,7
        int 21h                 ;wait for a key to exit
        cmp al,0                ;Function key?
        je f_key                ;Then clear buffer of character
        ret                     ;Else return
unk_error:
        lea si,ERRIND
        jmp write_ERR
Error Endp


;Procedure  Init_Midi
;Purpose  Initializes MPU, turns Midi Thru off, and change synthetizer
;         to program 0

Init_Midi proc
        mov al,rst                    ;reset Mpu
        call send_command
        mov al,midioff                ;Set Midi Thru off
        call send_command
        call PROGRAM                  ;Initialize to default program (0)
        ret
Init_Midi endp

;Procedure Program
;Purpose  Sends selected program to synthetizer

Program Proc
        mov al,WTSD             ;Want to send data command
        call send_command
        call drr_rout           ;Ready to receive data?
        mov dx,dataport
        mov al,0c0h             ;Program change MIDI code
        add al,Dft_Ch           ;Send to selected channel
        out dx,al               ;Out to dataport
        call drr_rout           ;Ready to receive data?
        mov al,DFT_PROG         ;Send selected program
        out dx,al
        call SlPr               ;Write program's name to screen
        ret
Program endp

;Procedure  Write_name
;Purpose Writes programs name to screen
;Input  DS:SI points to program's name buffer

Write_Name Proc
        push si
        push di
        push es
        mov ax,VideoSeg  ;video buffer segment
        mov es,ax       ;into ES
        mov di,330      ;DI video buffer offset for first program name
        cld
        mov ah,Col1     ;atributte into AH
        mov cx,16       ;16 lines
LOOP_WN2:
        push cx         ;Save number of lines
        push di         ;save offset
        mov cx,72       ;72 characters per line
LOOP_WN1:
        lodsb           ;first character into AL
        cmp VideoSeg,0b000h      ;If mono monitor write directly to screen
        je Store_Char
        call Retrace            ;(LI.LIB)Else wait for retrace to write
        jmp WN3
Store_Char:
        stosw           ;character and atributte into screen
WN3:
        loop LOOP_WN1   ;write next character
        pop di          ;restore original DI
        add di,160      ;one line down  (DI+160 = next line)
        pop cx          ;restore count of lines
        loop LOOP_WN2   ;go write next line
        pop es
        pop di
        pop si
        ret
Write_Name Endp

;Procedure Select Prog
;Purpose  Selects a program, and controls cursor movement

Select_Prog Proc
       call HL_PROG     ;highlight cursor position program's name
SL_PRA:
       mov ah,7         ;wait for input from keyboard
       int 21h
       cmp al,13        ;Carriage return = program has been selected
       jne SL_PR1       ;Exit with carry flag clear to signal selection
       clc
       ret
SL_PR1:
       cmp al,27        ;Escape?
       jne SL_PR2
       stc              ;Exit with carry flag set to signal desire to quit
       ret
SL_PR2:
       cmp al,0         ;If AL=0 then a function key was pressed
       jne SELECT_PROG  ;Else wait for another character
       mov ah,7
       int 21h          ;Get function key code
       lea bx,KE_TB     ;BX points to function key table
SL_PR3:
       cmp [bx],byte ptr 0      ;if BX points to 0 end of table
       je SL_PRA                ;unknown function key, jump to wait for key input
       cmp [bx],al              ;If match found
       je KEY_OK                ;jump to execute
       add bx,3                 ;Else continue searching
       jmp SL_PR3
KEY_OK:
       inc bx                   ;BX+1 points to offset of procedure
       call word ptr [bx]       ;call selected option
       call WRITE_NAME          ;rewrite programs name
       jmp SELECT_PROG          ;loop
Select_Prog Endp


;Procedure Hl_Prog
;Purpose  Highlights cursor position program

Hl_Prog Proc
        xor ax,ax
        mov al,DFT_prog ;Default program number into AL
        inc al          ;Program 0 = Program 1 etc.
        mov bl,8        ;Calculate programs name position
        div bl          ;on screen
        cmp ah,0
        jne NO_8
        add al,1
        mov ch,al
        mov al,136
        jmp P8
NO_8:
        add al,2   ;line number
        mov ch,al
        mov bl,ah
        mov al,9
        mul bl
        sub al,4   ;column number
        mov bl,2   ;Column * 2
        mul bl
P8:
        xor ah,ah
        push ax
        mov al,160
        mul ch       ;Line * 160
        mov di,ax
        pop ax
        add di,ax       ;(Line * 160) + (Column * 2) = video buffer offset
        inc di          ;add one to modify atributte ONLY
        push es         ;save ES
        mov ax,VideoSeg  ;video segment
        mov es,ax       ;to ES
        mov al,70h      ;Reverse video atributte into AL
        cld
        mov cx,8        ;maximum number of letters of each name
HL_PR1:
        stosb           ;send atribbute to screen
        inc di          ;move DI to point to next
        loop HL_PR1     ;Loop
        pop es
        stc
        ret
HL_PROG endp


;Procedures Up,Down,Right and Left
;Purpose  Move cursor

UP proc
        cmp DFT_PROG,7  ;If default program
        jbe UP1         ;is < or = 7 then cursor is at top line
        sub DFT_PROG,8  ;else move it one line up
        ret
UP1:
        add DFT_PROG,120  ;move it to bottom line
        ret
UP endp

DOWN PROC
        cmp DFT_PROG,120 ;If Default program
        jae DOWN2        ;is > or = 120 then  cursor is at the bottom line
        add DFT_PROG,8   ;else move it one line down
        ret
down2:
        sub DFT_PROG,120 ;move it to top line
        ret
DOWN ENDP

Left proc
        cmp DFT_PROG,0  ;If default program
        je LEFT1        ;=0 then go to
        dec DFT_PROG    ;else program=program - 1
        RET
LEFT1:
        mov DFT_PROG,127  ;program 127
        ret
left endp

right proc
        cmp DFT_PROG,127  ;If default program
        je R2             ;=127 then
        inc DFT_PROG      ;else Program = program +1
        RET
R2:
        mov DFT_PROG,0    ;go to program 0
        RET
right endp

;Procedure  Edit
;Purpose Edits a program's name, saves or loads programs name file

Edit proc
        push ax
        push bx
        push cx
        push dx
        push si
        call disp_edmenu     ;Display edit's menu
        jc Exit_EDIT         ;If carry set ESC was pressed, Exit
EDIT1:
        cmp [si+2],byte ptr 1   ;if equal
        jne EDIT2
        call Name_Prog          ;Name option was selected, call procedure
        jmp Exit_Edit           ;and exit
EDIT2:
        cmp [si+2],byte ptr 2
        jne Edit3               ;if equal
        call Save_Names         ;Save option was selected
        jmp Exit_Edit           ;call Proc and exit
Edit3:
        call Load_Names         ;Else Load was selected, call Proc
Exit_edit:
        mov [si+2],byte ptr 1   ;put option 1 (EDIT) as default option
        pop si                  ;in edit menu table for next call
        pop dx
        pop cx
        pop cx
        pop ax
        ret
Edit endp

;Procedure Name_Prog
;Purpose  Asks for program's name

Name_Prog Proc
        push si
        call NAME_BOX   ;Displays a box for entering program's name
        mov ah,2
        mov bh,0
        mov dh,15
        mov dl,40
        int 10h         ;Set cursor position
        lea dx,PROG_NAME_BF       ;DX points to program's buffer
        mov bl,COL2               ;reverse video atributte
        call KEYB                 ;(LI.LIB) wait for input from keyboard
        mov si,dx                 ;SI points program's name buffer
        cmp [si+1],byte ptr 0ffh  ;if [SI+1]=0ffh ESC was pressed
        je EXIT_NAME              ;EXIT
NAME_PROG1:                       ;Move new name to Program's name data
        push es                   ;buffer
        xor ax,ax
        mov al,DFT_PROG           ;Default program number * 9 =
        mov bl,9
        mul bl                    ;offset into buffer
        lea di,prog_nom           ;DI=points to first name
        add di,ax                 ;DI+AX=to selected program name
        push ds
        pop es                    ;Make ES=DS
        push di
        mov al,20h                ;Spaces into AL
        mov cx,8
        rep stosb                 ;Erase previous name with spaces
        pop di                    ;Restore DI (DI points to old name offset)
        mov si,offset PROG_NAME_BF+3  ;SIpoints to new name
        cld
        mov cl,[si-2]             ;number of characters entered to CX
        rep movsb                 ;move new name
        pop es
EXIT_NAME:
        mov ah,2                  ;move cursor out of screen
        mov bh,0
        mov dh,25
        mov dl,0
        int 10h
        pop si
        ret
Name_Prog Endp


;Procedure  Save_Names
;Purpose Saves programs'name file

Save_Names proc
        push si
        push di
        call FILE_BOX           ;Displays box for entering name
        lea si,filename         ;SI points to filename in data
        mov ax,0
        mov bl,col2
        mov ch,15
        mov cl,28
        call WRITE              ;(LI.LIB) write filename in DATA
        mov ah,2
        mov bh,0
        mov dh,15
        mov dl,28
        int 10h                 ;position cursor
        lea dx,FILENAME_BF
        mov bl,COL2
        call KEYB               ;(LI.LIB) wait for input
        mov si,dx
        cmp [si+1],byte ptr 0ffh  ;If [SI+1]<>0ffh continue
        jne save_ok               ;Else ESC was pressed
        lea di,filename
        call CLEAR_BF             ;clear buffer of data
        jmp EXIT_SAVE             ;and exit
save_ok:
        @makfil filename          ;Create a file
        jnc save1                 ;Carry=error
        call ERROR                ;Call error routine
        jmp EXIT_SAVE             ;and exit
save1:
        mov handle,ax
        @write prog_nom,1152,handle ;write data to file
        cmp ax,cx
        je SAVE2
        mov ax,99
        call ERROR
SAVE2:
        @closfil handle           ;close file
        call ProgFl               ;write filename to screen
EXIT_save:
        @SETCURPOS 0,25,0         ;move cursor out of screen
        pop di
        pop si
        ret
Save_Names endp

;Procedure Load_Names
;Purpose Loads program's name file

Load_Names Proc
        push si
        push di
        call FILE_BOX          ;Display box for filename
        lea si,filename
        mov ax,0
        mov bl,col2
        mov ch,15
        mov cl,28
        call WRITE            ;write filename in DATA (If any)
        @SETCURPOS 28,15,0    ;Position cursor
        lea dx,FILENAME_BF
        mov bl,COL2
        call KEYB             ;(LI.LIB) wait for input
        mov si,dx
        cmp [si+1],byte ptr 0ffh
        jne load_ok             ;[SI+1]<>0ffh?, continue
        lea di,filename
        call CLEAR_BF           ;Else ESC was pressed
        jmp EXIT_LOAD           ;clear buffer and exit
load_ok:
        @Openfil filename,0     ;Open file
        jnc load1
        call ERROR
        jmp EXIT_LOAD
load1:
        mov handle,ax
        @read prog_nom,1152,handle   ;read data
        cmp ax,cx
        je LOAD2
        call ERROR
LOAD2:
        @closfil handle         ;close file
        call ProgFl             ;write filename to screen
        call program            ;write new program's name to screen
EXIT_load:
        @setcurpos 0,25,0       ;move cursor out of screen
        pop di
        pop si
        ret
Load_Names ENDP

;Procedure Clear_bf
;Purpose  Fills a buffer with spaces
;Input  DI points to buffer data area


Clear_bf proc
        push es
        push ds
        pop es          ;ES=DS
        mov cx,40       ;CX=Lenght of buffer data
        mov al,20h      ;AL=space
        rep stosb       ;fill buffer
        mov [di],byte ptr 0     ;put a 0 to the end
        pop es
        ret
Clear_bf endp

;Procedures Ch1 - Ch16
;Purpose  Selects output midi channel

Ch1 proc
        push si
        lea si,Ch_Table      ;channel menu table
        mov [Ch_table+2],1   ;Ch_table+2=default channel
        mov Dft_Ch,0         ;move Dft_Ch variable channel number
        call Display_Slct    ;(LI.LIB)Display selected channel on screen
        pop si
        ret
Ch1 endp

Ch2 proc
        push si
        lea si,Ch_Table
        mov [Ch_table+2],2
        mov Dft_Ch,1
        call Display_Slct
        pop si
        ret
Ch2 endp

Ch3 proc
        push si
        lea si,Ch_Table
        mov [Ch_table+2],3
        mov Dft_Ch,2
        call Display_Slct
        pop si
        ret
Ch3 endp

Ch4 proc
        push si
        lea si,Ch_Table
        mov [Ch_table+2],4
        mov Dft_Ch,3
        call Display_Slct
        pop si
        ret
Ch4 endp

Ch5 proc
        push si
        lea si,Ch_Table
        mov [Ch_table+2],5
        mov Dft_Ch,5
        call Display_Slct
        pop si
        ret
Ch5 endp

Ch6 proc
        push si
        lea si,Ch_Table
        mov [Ch_table+2],6
        mov Dft_Ch,5
        call Display_Slct
        pop si
        ret
Ch6 endp

Ch7 proc
        push si
        lea si,Ch_Table
        mov [Ch_table+2],7
        mov Dft_Ch,6
        call Display_Slct
        pop si
        ret
Ch7 endp

Ch8 proc
        push si
        lea si,Ch_Table
        mov [Ch_table+2],8
        mov Dft_Ch,7
        call Display_Slct
        pop si
        ret
Ch8 endp

Ch9 proc
        push si
        lea si,Ch_Table
        mov [Ch_table+2],9
        mov Dft_Ch,8
        call Display_Slct
        pop si
        ret
Ch9 endp

Ch10 proc
        push si
        lea si,Ch_Table
        mov [Ch_table+2],10
        mov Dft_Ch,9
        call Display_Slct
        pop si
        ret
Ch10 endp

Ch11 proc
        push si
        lea si,Ch_Table
        mov [Ch_table+2],11
        mov Dft_Ch,10
        call Display_Slct
        pop si
        ret
Ch11 endp

Ch12 proc
        push si
        lea si,Ch_Table
        mov [Ch_table+2],12
        mov Dft_Ch,11
        call Display_Slct
        pop si
        ret
Ch12 endp

Ch13 proc
        push si
        lea si,Ch_Table
        mov [Ch_table+2],13
        mov Dft_Ch,12
        call Display_Slct
        pop si
        ret
Ch13 endp

Ch14 proc
        push si
        lea si,Ch_Table
        mov [Ch_table+2],14
        mov Dft_Ch,13
        call Display_Slct
        pop si
        ret
Ch14 endp

Ch15 proc
        push si
        lea si,Ch_Table
        mov [Ch_table+2],15
        mov Dft_Ch,14
        call Display_Slct
        pop si
        ret
Ch15 endp

Ch16 proc
        push si
        lea si,Ch_Table
        mov [Ch_table+2],16
        mov Dft_Ch,15
        call Display_Slct
        pop si
        ret
Ch16 endp

;Procedure Read_Data
;Purpose  Reads data from MPU if it is not ready to receive data

read_data proc
        push ax
        push dx
        mov dx,dataport
        in al,dx
        pop dx
        pop ax
        ret
read_data endp

        end Sint





