

        DOSSEG
        .MODEL small

         include c:dos.inc
         include c:bios.inc


        .DATA

Public Sr_menu,Piano,Tmen1,Tmen2,Ch_table,Help_Menu

;External variables
Extrn VideoSeg:word,Col1:byte,Col2:byte,Col3:byte,filename:byte,Dft_Ch:byte
Extrn Dft_prog:byte,Prog_nom:byte,Cola:byte,colb:byte,colc:byte

;****************Title screen

        Piano label byte

   db '',10
   db '',10
   db '',10
   db '               ۰',10
   db '               ۰',10
   db '               ۰',10
   db '۰',10
   db '۰',0


TMen1 db 'Mini Librarian by Jos Rodrguez Alvira, 1988',0
TMen2 db 'Version 1.00',0
TMen3 db ' Press any key (of your computer) to continue. ',0

;****************Main menu data

Main_Menu DB ' ',70h,'F',70h,'1',70h,' ',70h,' ',7,'H',7
          DB 'e',7,'l',7,'p',7,' ',7,' ',7,' ',7,' ',7        ;F1 Help
          DB ' ',70h,'F',70h,'2',70h,' ',70h,' ',7,'N',7
          DB 'a',7,'m',7,'e',7,' ',7,' ',7,' ',7,' ',7        ;F2 Name
          DB ' ',70h,'F',70h,'3',70h,' ',70h,' ',7,'S',7,'e',7,'n',7
          DB 'd',7,'/',7,'R',7,'e',7,'c',7,'.',7,' ',7,' ',7,' ',7   ;F3 Sen/Rec
          DB ' ',70h,'F',70h,'4',70h,' ',70h,' ',7,'C',7,'h',7,'a',7
          DB 'n',7,'n',7,'e',7,'l',7,' ',7,' ',7,' ',7,' ',7       ;F4 Channel
          db ' ',70h,'E',70h,'S',70h,'C',70h,' ',70h
          db ' ',7,'Q',7,'u',7,'i',7,'t',7,0                       ;Esc Quit

Main_MenuB db 'Selected program:           Output Channel:     Program file:',0


;****************Edit menu table

Edit_Menu label byte    ;Data used by MENU (LI.LIB) to display
             db 3       ;and select option
             db 11
             db 1
             dw offset lettersa
             db 7,38
             DB 'E',0FH,'d',7,'i',7,'t',7,0  ;Edit
             db 9,38
             DB 'S',0FH,'a',7,'v',7,'e',7,0  ;Save
             db 11,38
             DB 'L',0FH,'o',7,'a',7,'d',7,0  ;Load

        lettersa db 'ESL'       ;letters for each option

        TitleA DB 'Name',0   ;Title Name

        Name_Str db 'Enter name:',0
        File_NameStr DB 'Enter filename:',0


;***************Send/receive menu


Sr_menu label byte
        db 2
        db 17
        db 2
        dw offset lettersc
        db 8,37
        db 'S',0fh,'e',7,'n',7,'d',7,' ',7,' ',7,' ',7,0
        db 10,37
        db 'R',0fh,'e',7,'c',7,'e',7,'i',7,'v',7,'e',7,0
        lettersc db 'SR'

        TitleC db 'S/R',0

Rmen1    db 'Ready to receive data,',10,10
         db 'Press any key to exit',0

Rmen2    db '    RECEIVING DATA    ',0

Rmen3    db ' Procedure complete,  ',10,10
         db '    Saving file      ',0


;****************Channel menu table

        Ch_table label byte
        db 16
        db 3
        db 1
        db 21
        db 47
        db '01',0,'02',0,'03',0,'04',0,'05',0,'06',0,'07',0,'08',0
        db '09',0,'10',0,'11',0,'12',0,'13',0,'14',0,'15',0,'16',0

        Ch_Window db 396 dup (0)
        Ch_mes    db '  Select Channel',10,10
                  db ' using arrows keys',10,10
                  db '    and ENTER',10,10
                  db 'Output Channel:',0


;****************Help Menu table

        Help_menu label byte
                db 4
                db 21
                db 1
                dw offset lettersHl
                db 6,34
                db 'G',0fh,'e',7,'n',7,'e',7,'r',7,'a',7,'l',7,' ',7,' ',7,0
                db 8,34
                db 'N',0fh,'a',7,'m',7,'e',7,'s',7,' ',7,' ',7,' ',7,' ',7,0
                db 10,34
                db 'S',0fh,'e',7,'n',7,'d',7,'/',7,'R',7,'e',7,'c',7,'.',7,0
                db 12,34
                db 'C',0fh,'h',7,'a',7,'n',7,'n',7,'n',7,'e',7,'l',7,' ',7,0

    lettersHl   db  'GNSC'

    TitleHl     db 'Help',0

;****************Color table

        Color_table1 label word         ;This tables are used
                dw offset Edit_menu     ;to change menu color if a mono
                dw offset Sr_menu       ;monitor is used
                dw offset Help_menu

        Color_Table2 label word

                dw offset Main_menu


         .CODE

Public Menu_Prog,Disp_EdMenu,Name_Box,File_Box,ProgFl,SlCh,SlPr
Public Disp_Srmenu,RReady,Receiving,RecOk,Disp_HlMenu,ChgeColor

;External procedures
Extrn Display_Slct:near,Box:near,Write:near,Menu:near,Window:near,Slct:near
Extrn M_color:near,W_color:near

;Procedure Menu_Prog
;Purpose  Prepare main screen

Menu_Prog Proc
        push ax
        push bx
        push cx
        push dx
        push si
        push es
        mov ah,6
        mov al,0
        mov bh,col1
        xor cx,cx
        mov dh,24
        mov dl,79
        int 10h         ;Clear screen
        mov ax,1
        mov bl,col1
        mov dh,19
        call BOX        ;(LI.LIB) draws a box
        mov ax,1
        mov ch,20
        mov dh,24
        mov dl,79
        call BOX
        mov ax,1
        mov ch,6
        mov cl,6
        mov dh,15
        mov dl,74
        mov bl,0fh
        call BOX
        mov ax,1
        lea si,main_menu
        mov ch,23
        mov cl,5
        call write      ;(LI.LIB) displays main menu
        mov ax,0
        lea si,main_menub
        mov ch,21
        mov cl,3
        mov bl,col1
        call write
        lea si,piano
        mov ch,7
        mov cl,7
        mov bl,0fh
        call write      ;(LI.LIB) Displays Piano
        lea si,Tmen1
        mov ch,2
        mov cl,18
        mov bl,col1
        call write
        lea si,Tmen2
        mov ch,4
        mov cl,34
        call write
        lea si,Tmen3
        mov ch,17
        mov cl,17
        mov bl,Col2
        call write
        lea si,Ch_table
        call Display_Slct      ;(LI.LIB) Displays default channel
        mov ah,2
        mov bh,0
        mov dh,25
        mov dl,0
        int 10h                 ;Move cursor out of screen
Mn1:
        mov ah,1
        int 16h                 ;Wait for a key
        jz Mn1
        pop es
        pop si
        pop dx
        pop cx
        pop bx
        pop ax
        ret
Menu_Prog ENDP


;Procedure Disp_EdMenu
;Purpose  Displays Edit menu

Disp_EdMenu proc
        mov ah,6
        mov al,0
        mov bh,cola
        mov ch,5
        mov cl,35
        mov dh,13
        mov dl,44
        int 10h         ;Clears window for menu
        mov ax,4
        mov bl,bh
        xor bh,bh
        call BOX        ;(LI.LIB) Draws a box
        mov ax,0
        mov bl,colc
        mov ch,5
        mov cl,38
        lea si,TITLEA
        call WRITE     ;(LI.LIB) Writes menu title
        lea si,edit_menu
        call MENU      ;(LI.LIB) Displays menu and select option
        ret
Disp_EdMenu Endp


;Procedure Name_Box
;Purpose  Displays a box for entering a program name

Name_Box Proc
        mov ah,6
        mov al,0
        mov bh,COLA
        mov ch,14
        mov cl,27
        mov dh,16
        mov dl,50
        int 10h         ;Clears window
        mov ax,1
        mov bl,bh
        xor bh,bh
        call BOX        ;(LI.LIB) Displays a box
        xor ax,ax
        mov bl,COLA
        mov ch,15
        mov cl,28
        lea si,name_str
        call WRITE      ;(LI.LIB) Displays string asking for name
        ret
Name_Box Endp


;Procedure File_Box
;Purpose  Displays a box for entering a filename

File_Box Proc
        mov ah,6
        mov al,0
        mov bh,COLA
        mov ch,14
        mov cl,10
        mov dh,16
        mov dl,69
        int 10h         ;Clear window
        mov ax,1
        mov bl,bh
        xor bh,bh
        call BOX        ;(LI.LIB) Draw a box
        xor ax,ax
        mov bl,COLA
        mov ch,15
        mov cl,12
        lea si,file_namestr
        call WRITE      ;(LI.LIB) Write prompt to screen
        ret
File_Box Endp

;Procedure SlPr
;Displays selected program's name

SlPr proc
        push ax
        push bx
        push cx
        push si
        push di
        push es
        xor ax,ax
        mov al,DFT_prog
        mov bl,9
        mul bl            ;Default program number * 9 = offset into data
        lea si,Prog_nom
        add si,ax         ;offset program name data + AX = selected program
        mov ax,VideoSeg
        mov es,ax         ;ES=Video buffer segment
        mov di,3402       ;DI=offset for program name
        mov ah,col2
        mov cx,8
SlPr1:
        lodsb
        stosw             ;write to video buffer
        loop SlPr1
        pop es
        pop di
        pop si
        pop cx
        pop bx
        pop ax
        ret
SlPr endp


;Procedure ProgFl
;Purpose  Displays selected program file name

ProgFl proc
        push ax
        push bx
        push cx
        push dx
        push si
        push di
        push ds
        push es
        push bp
        mov ah,6
        mov al,0
        mov bh,col1
        mov ch,21
        mov cl,65
        mov dh,21
        mov dl,73
        int 10h
        mov bp,sp       ;Clear window
        @GetFirst filename, ,ds    ;Strip filename of drive, path etc.
        mov di,3490             ;DI offset into video buffer
        mov ax,VideoSeg
        mov es,ax               ;ES segment of video buffer
        mov ah,col2
        mov si,9eh              ;SI points to offset of Disk Transfer Area (DTA)
        mov ds,[bp+2]           ;DS=ES
ProgFl1:
        lodsb                   ;move into AL
        cmp al,0                ;move until 0 found
        je EXIT_progFl
        stosw                   ;From AL to screen
        jmp ProgFl1
Exit_progFl:
        pop bp
        pop es
        pop ds
        pop di
        pop si
        pop dx
        pop cx
        pop bx
        pop ax
        ret
ProgFl endp

;Procedure SlCh
;Purpose  Displays and select output channel

SlCh proc
        push ax
        push bx
        push cx
        push dx
        push si
        push di
        lea di,Ch_window
        xor ax,ax
        mov ch,14
        mov cl,29
        mov dh,22
        mov dl,50
        mov bl,ColA
        call WINDOW      ;(LI.LIB) call window to save and clear area
        mov ax,1
        call BOX         ;write box
        xor ax,ax
        mov ch,15
        mov cl,31
        lea si,Ch_mes   ;(LI.LIB) write text to screen
        call Write
        lea si,Ch_table
        call Slct       ;(LI.LIB) select channel with arrow keys
        jc Exit_SlCh    ;if carry set ESC was pressed
        mov al,[si+2]   ;restore previously selected channel
        dec al
        mov Dft_Ch,al
Exit_SlCh:
        mov ax,1
        mov ch,14
        mov cl,29
        mov dh,22
        mov dl,50
        lea di,Ch_window
        call WINDOW     ;(LI.LIB) restore window
        call Display_Slct  ;display selected channel
        pop di
        pop si
        pop dx
        pop cx
        pop bx
        pop ax
        ret
SlCh endp

;Procedure Disp_SrMenu
;Purpose  Displays and selects option of Send/Rec Menu

Disp_Srmenu proc
        push ax
        push bx
        push cx
        push dx
        push si
        mov ah,6
        mov al,0
        mov bh,colA
        mov ch,6
        mov cl,35
        mov dh,12
        mov dl,45
        int 10h         ;Clear window
        mov ax,4
        mov bl,bh
        xor bh,bh
        call BOX        ;Draw box
        mov ax,0
        mov bl,colC
        mov ch,6
        mov cl,39
        lea si,TITLEC
        call WRITE      ;Write title
        lea si,Sr_menu
        call MENU       ;(LI.LIB) display menu and select option
        pop si
        pop dx
        pop cx
        pop bx
        pop ax
        ret
Disp_Srmenu endp

;Procedure RReady
;Purpose  Displays message telling program is ready to receive data
;         from syntethizer

RReady proc
        push ax
        push bx
        push cx
        push dx
        push si
        mov ah,6
        mov al,0
        mov bh,colA
        mov ch,7
        mov cl,28
        mov dh,11
        mov dl,52
        int 10h         ;Clear window
        mov ax,1
        mov bl,colA
        call BOX        ;(LI.LIB) draw box
        mov ch,8
        mov cl,30
        lea si,Rmen1
        xor ax,ax
        call Write      ;(LI.LIB) write to screen Rmen1
        pop si
        pop dx
        pop cx
        pop bx
        pop ax
        ret
RReady endp

;Procedure Receiving
;Purpose  Display message telling program is receiving data

Receiving proc
        push ax
        push bx
        push cx
        push si
        xor ax,ax
        mov bl,colC
        mov ch,8
        mov cl,30
        lea si,Rmen2
        call WRITE      ;(LI.LIB) Write Rmen2 to screen
        pop si
        pop cx
        pop bx
        pop ax
        ret
Receiving endp

;Procedure RecOk
;Purpose Displays message telling data has been received

RecOk  proc
        push ax
        push bx
        push cx
        push si
        xor ax,ax
        mov bl,colA
        mov ch,8
        mov cl,30
        lea si,Rmen3
        call WRITE      ;(LI.LIB) Write  Rmen3 to screen
        pop si
        pop cx
        pop bx
        pop ax
        ret
RecOk endp

;Procedure Disp_HlMenu
;Purpose  Display and select option of Help Menu

Disp_HlMenu proc
        mov ah,6
        mov al,0
        mov bh,colA
        mov ch,4
        mov cl,32
        mov dh,14
        mov dl,44
        int 10h
        mov ax,4
        mov bl,bh
        xor bh,bh
        call BOX
        mov ax,0
        mov bl,colC
        mov ch,4
        mov cl,37
        lea si,TITLEHl
        call WRITE
        lea si,Help_Menu
        call MENU
        ret
Disp_HlMenu Endp

;Procedure ChgeColor
;Purpose  Change default menu colors if color monitor present

ChgeColor proc
        push ax
        push cx
        push si
        lea si,color_table1
        mov cx,3
        mov al,cola
        push ax
        mov al,colb
        push ax
        mov al,colc
        push ax
        call M_Color            ;(LI.LIB) change menu colors
        lea si,color_table2
        mov cx,1
        mov al,col1
        push ax
        mov al,col2
        push ax
        mov al,col3
        push ax
        call W_Color            ;(Li.LIB) change string colors
        pop si
        pop cx
        pop ax
        ret
ChgeColor endp

        end

