


        DOSSEG
        .MODEL small

         include c:dos.inc
         include c:bios.inc


        .DATA

Extrn Help_menu:byte,Col1:byte

        Help1a label byte       ;Help Data

db '              Mini Librarian by Jos Rodrguez Alvira, 1988',10,10
db 'Mini Librarian allows you to send program change commands on any of the',10
db '16 MIDI channels, letting you control individually up to 16 synthetizers',10
db 'from your computer keyboard.',10,10
db 'Programs can be identified by numbers (default) or by any names or sym-',10
db 'bols you desire.',10,10
db 'It can also store on diskettes your synthetizers programs data.',10,10
db 'SELECTING A PROGRAM: Move the cursor to the desired program number using',10
db 'the arrow keys and press ENTER. (Be sure that your synthetizer is ready',10
db 'to receive program changes in the SELECTED CHANNEL, see channel help).',10,10
db '   PRESS ANY KEY',0

        Help1b label byte

db 'USING MENUS: Press the function key of the desired menu, a pop up menu',10
db 'will appear. Use the arrow keys to highlight the desired option and hit',10
db 'ENTER or press the first highlighted letter.',10,10
db 'To exit from a menu use the ESCAPE key.',10,10
db 'If you find this program useful you can send your contribution to:',10,10
db 'Jos Rodrguez Alvira, El Monte Sur 190, Apt. B-342, H. Rey, P.R., 00918',10
db '(You can contact me throught PAN by the name ALVIRA)',10,10
db 'You will be contacted of future updates, and the source code (assembly)',10
db 'will be send at your request. Suggestions or questions are welcome.',10,10
db '   PRESS ANY KEY to exit or F1 for more help.',0



        Help2 label byte

db '              Mini Librarian by Jos Rodrguez Alvira, 1988',10,10
db 'Name menu lets you assign names to each program.',10,10
db 'Move the cursor (highlight) to the program number you want to change,',10
db 'press F2 and select EDIT from the menu. You will be asked for the de-',10
db 'sired name.',10,10
db 'After you have named your programs you can save the names to a file',10
db 'using the SAVE option. Specify a path for your file unless you want',10
db 'to save it in the default drive.',10,10
db 'You can LOAD your programs names files using the LOAD option of the',10
db 'NAME menu or specifiying the name of the file when you invoke the',10
db 'program from DOS:   A>ML <Path>filename.ext',10,10
db '   PRESS ANY KEY to exit or F1 for more help.',0



        Help3 label byte


db '               Mini Librarian by Jos Rodrguez Alvira, 1988',10,10
db ' To send or receive data from your synthetizer press F3 to open up the',10
db ' SEND/RECEIVE menu and choose the desired option. In both cases you',10
db ' will be asked to give a filename.',10,10
db ' To RECEIVE: After you give a filename the program will display a message',10
db ' telling it is ready to receive data. You can now tell your synthetizer to',10
db ' start sending data. Once the program starts to receive data it displays',10
db ' the RECEIVING message on the screen. It will stop automatically when it',10
db ' receives an End Of eXlusive (EOX) message. Then it will save all data to',10
db ' a file. You can abort the operation at any moment by pressing any key.',10
db ' To SEND: Prepare your synthetizer to receive System Exclusive messages',10
db ' and select SEND from the menu.',10
db ' NOTE: DATA IS SEND IN THE SAME CHANNEL THAT IT WAS RECEIVED.',10,10
db '   PRESS ANY KEY to exit or F1 for more help.',0


        Help4 label byte

db '              Mini Librarian by Jos Rodrguez Alvira, 1988',10,10
db 'Program changes are transmitted throught the selected OUTPUT CHANNEL.',10,10
db 'The default channel is channel 1 (or channel zero if you count from 0',10
db 'to 15). To change channel press F4. A box will appear. Using the arrow',10
db 'keys you can now change the output channel. Press ENTER when the desi-',10
db 'red channel appears in the OUTPUT CHANNEL field.',10,10
db ' You can also change the OUTPUT CHANNEL by pressing the followings key',10
db ' combinations:',10,10
db '                  ALT/F1 - ALT/F10  === channels 1 to 10',10
db '                Shift/F1 - Shift/F6 === channels 11 to 16',10,10
db '   PRESS ANY KEY to exit or F1 for more help.',0


        .CODE

Public Help

Extrn Disp_HlMenu:near,Write:near

;Procedure Help
;Purpose  Displays help menu and call procedure according to choice

Help proc
        push ax
        push bx
        push cx
        push dx
        push si
        call Disp_HlMenu   ;(LI.LIB) Display menu and select option
        jc Exit_Help2      ;If carry ESC was pressed, Exit
        mov ah,6
        mov al,0
        mov bh,col1
        mov ch,1
        mov cl,1
        mov dh,18
        mov dl,78
        int 10h                 ;clear screen
        cmp byte ptr[si+2],1
        jne Hl2
        call HelpMain           ;If 1 call main help
        jmp Exit_help
Hl2:
        cmp byte ptr[si+2],2
        jne Hl3
        call HelpEdit           ;If 2 Edit help
        jmp Exit_help
Hl3:
        cmp byte ptr[si+2],3
        jne Hl4
        call HelpSr             ;If 3 Send/Receive help
        jmp Exit_help
Hl4:
        call HelpCh             ;Else channel help
Exit_help:
        mov ah,1
        int 16h
        jz Exit_help
        mov ah,6
        mov al,0
        mov bh,col1
        mov ch,1
        mov cl,1
        mov dh,18
        mov dl,78              ;clear screen
        int 10h
Exit_help2:
        pop si
        pop dx
        pop cx
        pop bx
        pop ax
        ret
Help endp


;Procedure HelpMain
;Purpose Displays main help menu

HelpMain proc
        lea si,help1a
        xor ax,ax
        mov ch,2
        mov cl,4
        mov bl,col1
        call write      ;(LI.LIB) display data
HM1:
        mov ah,7
        int 21h         ;wait for a key
        cmp al,0
        je HM1
        mov ah,6
        mov al,0
        mov bh,col1
        mov ch,4
        mov cl,4
        mov dh,18
        mov dl,75
        int 10h
        lea si,help1b     ;display next help
        xor ax,ax
        mov ch,4
        mov cl,4
        mov bl,col1
        call write
        ret
HelpMain endp

HelpEdit proc
        lea si,help2
        xor ax,ax
        mov ch,2
        mov cl,6
        mov bl,col1
        call write
        ret
HelpEdit endp

HelpSr proc
        lea si,help3
        xor ax,ax
        mov ch,2
        mov cl,4
        mov bl,col1
        call write
        ret
HelpSr endp

HelpCh proc
        lea si,help4
        xor ax,ax
        mov ch,2
        mov cl,4
        mov bl,col1
        call write
        ret
HelpCh endp

        end




